# -*- coding: utf-8 -*-
""" db_widgets

	Customize forms and grids widgets
	$Id$
	
"""
from datetime import datetime
pgm = local_import('plugin_dbui')

#-------------------------------------------------------------------------------
#
# Customize the main viewport
# hide some tables depending on the user role
#
#-------------------------------------------------------------------------------
#pgm.hidden_tables('publishers', 
#				  'categories_aeres',
#				  'categories_commission',
##				  'collaborations',
#				  'countries',
##				  'teams',
#				  'projects',
#				  'publishers')

#-------------------------------------------------------------------------------
#
# add plugin for all grids
#
#-------------------------------------------------------------------------------
pgm.customize_grid(plugins=['pGridRowEditorContextMenu',
						    'pGridPaging'])


#-------------------------------------------------------------------------------
#
# customize the form for the publications object
# Group fields in fieldset
#
#-------------------------------------------------------------------------------

# customize some fields
pgm.customize_field('publications', 'year', maxValue=datetime.now().year)

# add fieldset to form
fields = ['title',
		  'authors',
		  'id_collaborations',
		  'id_publishers',
		  'year',
		  'doi',
		  'volume',
		  'first_page',
		  'last_page',
		  'e_print']

pgm.customize_form_with_field_set('publications', T('General'), fields, 
															 	collapsible=True,
															 	flex=1)

fields = ['conference_title',
		  'conference_url',
 		  'conference_start',
		  'conference_end',
	 	  'conference_town',
	 	  'id_countries',
 	 	  'conference_speaker']

pgm.customize_form_with_field_set('publications', T('Conference'), fields,
																   spacer=78,
												 				   collapsible=True,
																   flex=1)


fields = ['authors_cppm',
		  'id_teams',
		  'id_projects',
	   	  'id_categories_aeres']

pgm.customize_form_with_field_set('publications', 'CPPM', fields,
												 		  collapsible=True,
												 		  flex=1)

fields = ['report_numbers', 'id_reports']

pgm.customize_form_with_field_set('publications', T('Report'), fields,
															   spacer=90,
												               collapsible=True,
												 			   flex=1)


pgm.customize_form('publications',
					buttonAlign='right', 
					labelWidth=100,
				    labelAlign='right',
#				    layout={'type': 'hbox', 'padding': 0, 'align': 'stretchmax'},
					layout={'type': 'table', 'columns': 2},
				    layoutConfig={'tableAttrs': {'style': {'width': '100%', 'cellspacing': 10}}},
#				    layout='table',
#				    layoutConfig={'columns': 2,
#								  'tableAttrs': {'style': {'width': '100%', 'cellspacing': 10}}},
#				    default={'frame': True, 'width': 200, 'heigth': 200},
#					width=700,
#					anchor='100%'
				    )

#-------------------------------------------------------------------------------
#
# customize the grid for the publications object
#
#-------------------------------------------------------------------------------

# add a template column handling general information
tpl = ['{PublicationsTitle}<br>',
	   '{PublicationsAuthors}',
	   '<tpl if="PublicationsId_collaborations  &gt; 1">, {CollaborationsCollaboration}</tpl>',
	   '<tpl if="PublicationsDoi"><br>{PublicationsDoi}</tpl>',
	   '<tpl if="PublicationsId_publishers  &gt; 1"><br>{PublishersAbbreviation}',
	       '<tpl if="PublicationsVolume"> {PublicationsVolume}</tpl>',
	   	   '<tpl if="PublicationsYear"> ({PublicationsYear}) </tpl>',
	   	   '<tpl if="PublicationsFirst_page"> {PublicationsFirst_page}</tpl>',
	   	   '<tpl if="PublicationsLast_page">-{PublicationsLast_page}</tpl>',
	   '</tpl>',
	   '<tpl if="PublicationsE_print"><br>{PublicationsE_print}</tpl>',
	   '<tpl if="PublicationsConference_title"><br><br>{PublicationsConference_title}',
	   		'<tpl if="PublicationsConference_town"><br>{PublicationsConference_town}</tpl>',
	   		'<tpl if="CountriesCountry">, {CountriesCountry}</tpl>',
	   		'<tpl if="PublicationsConference_start">, {PublicationsConference_start}</tpl>',
	   		'<tpl if="PublicationsConference_end"> - {PublicationsConference_end}</tpl>',
	   		'<tpl if="PublicationsConference_url"><br>{PublicationsConference_url}</tpl>',
	   		'<br>%s: {PublicationsConference_speaker}' % T('Speaker'),
	   '</tpl>',
	   '<tpl if="PublicationsReport_numbers"><br><br>',
	   		'<tpl if="PublicationsId_reports &gt; 1">{ReportsType}, </tpl>',
	   		'{PublicationsReport_numbers}',
	   '</tpl>',
	   '<br>Auteurs CPPM : {PublicationsAuthors_cppm}'
	   ]

hidden = ['title', 
		  'authors', 
		  'id_collaborations', 
		  'id_publishers',
		  'doi', 
		  'volume',
		  'first_page',
		  'last_page',
		  'e_print',
		  'conference_title',
		  'conference_url',
		  'conference_start',
		  'conference_end',
		  'conference_town',
		  'id_countries',
		  'conference_speaker',
		  'report_numbers',
		  'id_reports',
		  'authors_cppm']

pgm.customize_grid_with_template_column('publications', T('Publication'), tpl, 
									                                   	  1, 
									                                   	  hidden,
									                                      width=700)
