""" $Id$
	Author: R. Le Gac
"""

__version__ = "$Revision$"

import pprint

KEYWORD_MISSING = "The keyword '%s' is missing or undefined."

class BaseSvc:
	
	def __init__(self, db):
		self._db = db
		self._vars = None


	def _debug(self, *args):
		"""Print args if the keyword debug is in the request and
		if the associate value is true.

		"""
		if ("debug" in self._vars) and (self._vars.debug == 'true'):
			for arg in args:
				pprint.pprint(arg)


	def _is_keyword(self, keyword):
		"""Raise an exception if the steering keyword is not defined."""
		if not (keyword in self._vars and self._vars[keyword]):
			raise Exception, KEYWORD_MISSING % keyword  

	
	def _list(self, val):
		""" If val is a list return val.  
		Otherwise, build a list containing val
		
		"""
		if not isinstance(val, (list, tuple)):
			 val = [val]
		return val


	def proceed(self, vars):
		"""Proceed the request sends via the POST/GET method.

		"""
		self._vars = vars
