/**
 * A pre-configured combobox displaying a set of predefined value.
 * 
 * MANDATORY PROPERTIES:
 * 		- model
 *  
 * All configuration properties of Ext.form.ComboBox are understood.
 * 
 * @extends Ext.form.ComboBox 
 * @author $Author$
 * @version $Id$
 *
 */
Ext.namespace('App.form');

App.form.SetBox = Ext.extend(Ext.form.ComboBox, {

	/**
	 * @cfg {Object} model Object to configure the widget. 
	 * It is provided by the server and contains the following keys:
	 * 	{ setData: [...]} 
	 */
	model: null,

	/**
	 * Predefined setting
	 *
	 */
	editable: false,
	emptyText: "Select...",
	selectOnFocus: true,
	triggerAction: 'all',
	typeAhead: true,
	
	/**
	 * private method require by the ExtJs component model
	 */	
	initComponent: function(){

		if (!this.model){
			throw new Error("the property model is missing !!!")
		}
		
		// setup the store
		var li = [];
		for (var i=0; i < this.model.setData.length; i++){
			li.push([this.model.setData[i]]);
		}		

	    this.store = new Ext.data.ArrayStore({
	        fields: [this.model.name],
	        data : li
	    });

		// display field an mode
		this.displayField = this.model.name;
		this.mode = 'local';
		
		// construct the underlying class. DON'T MOVE
		App.form.SetBox.superclass.initComponent.call(this);

	}
});

Ext.reg('xsetbox', App.form.SetBox);