/**
 * grid_2.js
 *
 * To test and debug grid widget using MathJax
 * $Id$
 *
 */
Ext.namespace('App.grid');

/**
 * main function to get configuration information
 */
mainCfg = function(){

	// Expose the remote service cfgSvc
	Ext.Direct.addProvider(App.cfgSvcMethods);
	
	// Request form model from the server
	cfgSvc.getGridModel('publications', mainGrid);
	
};

/**
 * main function to instanciate the grid
 * @param {Object} provider
 * @param {Object} response
 */
mainGrid = function(provider, response){

	var cfg = response.result;
	
//	console.log("Grid Model");
//	console.dir(cfg);
	
	// instenciate the grid
	var grid = new App.grid.Grid(cfg);

	grid.getView().on('refresh', function(){
		console.debug('onRefresh');
		MathJax.Hub.PreProcess();
		MathJax.Hub.Process();
	})
	
	// the viewport to hold the grid
	// 	using all space available in the browser
	var vp = new Ext.Viewport({
		region: 'center',
		layout: 'fit',
		items: [grid]
	});
	
	vp.render('appmain');
};


Ext.onReady(function(){

    Ext.QuickTips.init();

	// load the MathJax librayri
	App.withMathJax ? App.loadMathJax(mainCfg) : mainCfg();

});